<?php
namespace Bushelpowered\Api\Aggregator\Crm\V1\Request;
        
class GetActivitiesByCustomerIdRequest implements \Bushelpowered\Api\Common\RequestsPagination
{
    /** @var string $id The id of the customer to get activities for.*/
    public string $id;
    /** @var null|\Bushelpowered\Api\Aggregator\Crm\V1\Request\ActivityPagination $pagination */
    public ?\Bushelpowered\Api\Aggregator\Crm\V1\Request\ActivityPagination $pagination = null;

    /**
     * @param  string  $id The id of the customer to get activities for.
     * @param  null|\Bushelpowered\Api\Aggregator\Crm\V1\Request\ActivityPagination  $pagination 
     */
    public function __construct(string $id, ?\Bushelpowered\Api\Aggregator\Crm\V1\Request\ActivityPagination $pagination)
    {
        $this->id = $id;
        $this->pagination = $pagination;
    }
    
    /**
     * @return null|\Bushelpowered\Api\Aggregator\Crm\V1\Request\ActivityPagination 
     */
    public function getPagination(): ?\Bushelpowered\Api\Aggregator\Crm\V1\Request\ActivityPagination
    {
        return $this->pagination;
    }
}