<?php
namespace Bushelpowered\Api\Fulfillment\Contract\V1\Response;
        
class ContractListItemResponse implements \Bushelpowered\Api\Common\HasCreatedAtTimestamp, \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $id The id of the contract*/
    public string $id;
    /** @var string $remoteId The id of contract in the remote system*/
    public string $remoteId;
    /** @var null|string $displayId The display id of contract*/
    public ?string $displayId = null;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity;
    /** @var \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $destinationLocation */
    public \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $destinationLocation;
    /** @var null|string $deliveryPeriodStart  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deliveryPeriodStart = null;
    /** @var null|string $deliveryPeriodEnd  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $deliveryPeriodEnd = null;
    /** @var null|float $quantityContracted */
    public ?float $quantityContracted = null;
    /** @var null|float $quantityRemaining */
    public ?float $quantityRemaining = null;
    /** @var null|string $quantityUom */
    public ?string $quantityUom = null;
    /** @var string $contractType */
    public string $contractType;
    /** @var null|float $pricing The price of the contract. If null it is considered 'unpriced'*/
    public ?float $pricing = null;
    /** @var null|string $status The status of the contract, it is either open or closed.*/
    public ?string $status = null;
    /** @var null|string $remoteCreatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $remoteCreatedAt = null;
    /** @var null|string $remoteUpdatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public ?string $remoteUpdatedAt = null;
    /** @var string $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $createdAt;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $id The id of the contract
     * @param  string  $remoteId The id of contract in the remote system
     * @param  null|string  $displayId The display id of contract
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse  $account 
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse  $company 
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse  $commodity 
     * @param  \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse  $destinationLocation 
     * @param  null|string  $deliveryPeriodStart  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $deliveryPeriodEnd  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|float  $quantityContracted 
     * @param  null|float  $quantityRemaining 
     * @param  null|string  $quantityUom 
     * @param  string  $contractType 
     * @param  null|float  $pricing The price of the contract. If null it is considered 'unpriced'
     * @param  null|string  $status The status of the contract, it is either open or closed.
     * @param  null|string  $remoteCreatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  null|string  $remoteUpdatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $createdAt Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $id, string $remoteId, ?string $displayId, \Bushelpowered\Api\Fulfillment\Common\V1\Response\AccountResponse $account, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CompanyResponse $company, \Bushelpowered\Api\Fulfillment\Common\V1\Response\CommodityResponse $commodity, \Bushelpowered\Api\Fulfillment\Common\V1\Response\LocationResponse $destinationLocation, ?string $deliveryPeriodStart, ?string $deliveryPeriodEnd, ?float $quantityContracted, ?float $quantityRemaining, ?string $quantityUom, string $contractType, ?float $pricing, ?string $status, ?string $remoteCreatedAt, ?string $remoteUpdatedAt, string $createdAt, string $updatedAt)
    {
        $this->id = $id;
        $this->remoteId = $remoteId;
        $this->displayId = $displayId;
        $this->account = $account;
        $this->company = $company;
        $this->commodity = $commodity;
        $this->destinationLocation = $destinationLocation;
        $this->deliveryPeriodStart = $deliveryPeriodStart;
        $this->deliveryPeriodEnd = $deliveryPeriodEnd;
        $this->quantityContracted = $quantityContracted;
        $this->quantityRemaining = $quantityRemaining;
        $this->quantityUom = $quantityUom;
        $this->contractType = $contractType;
        $this->pricing = $pricing;
        $this->status = $status;
        $this->remoteCreatedAt = $remoteCreatedAt;
        $this->remoteUpdatedAt = $remoteUpdatedAt;
        $this->createdAt = $createdAt;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Created date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getCreatedAt(): string
    {
        return $this->createdAt;
    }
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}