<?php
namespace Bushelpowered\Api\Fulfillment\Threshold\V1\Request;
        
class UpdateThresholdRequest 
{
    /** @var string $id The id of the threshold, found in the ThresholdResponse object*/
    public string $id;
    /** @var null|float $minValue The lower value in the range we want to check for.*/
    public ?float $minValue = null;
    /** @var null|float $maxValue The higher value in the range we want to check for.*/
    public ?float $maxValue = null;

    /**
     * @param  string  $id The id of the threshold, found in the ThresholdResponse object
     * @param  null|float  $minValue The lower value in the range we want to check for.
     * @param  null|float  $maxValue The higher value in the range we want to check for.
     */
    public function __construct(string $id, ?float $minValue, ?float $maxValue)
    {
        $this->id = $id;
        $this->minValue = $minValue;
        $this->maxValue = $maxValue;
    }
    

}