<?php
namespace Bushelpowered\Api\Iam\Keycloak\V1\Model;
        
class UserIdentifiers implements \Bushelpowered\Api\Common\HasUpdatedAtTimestamp
{
    /** @var string $userId The id of the user, sometimes just called bushel_id.*/
    public string $userId;
    /** @var \Bushelpowered\Api\Platform\Authorization\V1\Request\Identifier[] $identifiers */
    public array $identifiers;
    /** @var string $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $updatedAt;

    /**
     * @param  string  $userId The id of the user, sometimes just called bushel_id.
     * @param  \Bushelpowered\Api\Platform\Authorization\V1\Request\Identifier[]  $identifiers 
     * @param  string  $updatedAt Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function __construct(string $userId, array $identifiers, string $updatedAt)
    {
        $this->userId = $userId;
        $this->identifiers = $identifiers;
        $this->updatedAt = $updatedAt;
    }
    
    /**
     * @return string Updated date-time within the microservice. of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     */
    public function getUpdatedAt(): string
    {
        return $this->updatedAt;
    }
}