<?php
namespace Bushelpowered\Api\Platform\File\V1\Request;
        
class GetFileUrlRequest implements \Bushelpowered\Api\Platform\File\V1\Common\HasFileUrlOptions
{
    /** @var string $fileId The id of the file obtained when storing the file.*/
    public string $fileId;
    /** @var null|\Bushelpowered\Api\Platform\File\V1\Common\Transformations $transformations */
    public ?\Bushelpowered\Api\Platform\File\V1\Common\Transformations $transformations = null;
    /** @var int $validFor The number of seconds the url is valid for. Max 604800.*/
    public int $validFor;
    /** @var null|\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition $contentDisposition */
    public ?\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition $contentDisposition = null;

    /**
     * @param  string  $fileId The id of the file obtained when storing the file.
     * @param  null|\Bushelpowered\Api\Platform\File\V1\Common\Transformations  $transformations 
     * @param  int  $validFor The number of seconds the url is valid for. Max 604800.
     * @param  null|\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition  $contentDisposition 
     */
    public function __construct(string $fileId, ?\Bushelpowered\Api\Platform\File\V1\Common\Transformations $transformations, int $validFor, ?\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition $contentDisposition)
    {
        $this->fileId = $fileId;
        $this->transformations = $transformations;
        $this->validFor = $validFor;
        $this->contentDisposition = $contentDisposition;
    }
    
    /**
     * @return int The number of seconds the url is valid for. Max 604800.
     */
    public function getValidFor(): int
    {
        return $this->validFor;
    }
    /**
     * @return null|\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition 
     */
    public function getContentDisposition(): ?\Bushelpowered\Api\Platform\File\V1\Common\ContentDisposition
    {
        return $this->contentDisposition;
    }
}