<?php
namespace Bushelpowered\Api\Platform\Tenant\V1\Request;
        
class GetOrCreateCompanyRequest 
{
    /** @var string $companySlug The company slug identifier used by Centre.  This is equivalent to the Tenant Service datasource slug.*/
    public string $companySlug;
    /** @var string $companyName The company name used by Centre.*/
    public string $companyName;
    /** @var null|string $parentSlug The parent company slug used by Centre. This is used when there is a partner company.*/
    public ?string $parentSlug = null;

    /**
     * @param  string  $companySlug The company slug identifier used by Centre.  This is equivalent to the Tenant Service datasource slug.
     * @param  string  $companyName The company name used by Centre.
     * @param  null|string  $parentSlug The parent company slug used by Centre. This is used when there is a partner company.
     */
    public function __construct(string $companySlug, string $companyName, ?string $parentSlug)
    {
        $this->companySlug = $companySlug;
        $this->companyName = $companyName;
        $this->parentSlug = $parentSlug;
    }
    

}