<?php
namespace Bushelpowered\Api\Trade\Offers\V1\Request;
        
class CreateOrderFilledRequest 
{
    /** @var int $quantity */
    public int $quantity;
    /** @var float $price */
    public float $price;
    /** @var float $basisPrice */
    public float $basisPrice;
    /** @var float $futuresPrice */
    public float $futuresPrice;
    /** @var null|string $comments */
    public ?string $comments = null;
    /** @var int $accountId */
    public int $accountId;
    /** @var string $erpAccountId */
    public string $erpAccountId;
    /** @var string $erpCommodityId */
    public string $erpCommodityId;
    /** @var string $erpLocationId */
    public string $erpLocationId;
    /** @var string $orderCreatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $orderCreatedAt;
    /** @var string $expiresAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $expiresAt;
    /** @var bool $forceFill */
    public bool $forceFill;
    /** @var bool $careOrder */
    public bool $careOrder;
    /** @var string $contractSymbol */
    public string $contractSymbol;
    /** @var int $pricingType */
    public int $pricingType;
    /** @var string $unitOfMeasure */
    public string $unitOfMeasure;
    /** @var string $shortInstrumentGroupName */
    public string $shortInstrumentGroupName;
    /** @var string $commodityName */
    public string $commodityName;
    /** @var string $locationName */
    public string $locationName;
    /** @var string $exchangeAbbreviation */
    public string $exchangeAbbreviation;
    /** @var string $futuresSymbol */
    public string $futuresSymbol;
    /** @var string $deliveryStart  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $deliveryStart;
    /** @var string $deliveryEnd  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00*/
    public string $deliveryEnd;
    /** @var string $chainOrderId */
    public string $chainOrderId;

    /**
     * @param  int  $quantity 
     * @param  float  $price 
     * @param  float  $basisPrice 
     * @param  float  $futuresPrice 
     * @param  null|string  $comments 
     * @param  int  $accountId 
     * @param  string  $erpAccountId 
     * @param  string  $erpCommodityId 
     * @param  string  $erpLocationId 
     * @param  string  $orderCreatedAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $expiresAt  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  bool  $forceFill 
     * @param  bool  $careOrder 
     * @param  string  $contractSymbol 
     * @param  int  $pricingType 
     * @param  string  $unitOfMeasure 
     * @param  string  $shortInstrumentGroupName 
     * @param  string  $commodityName 
     * @param  string  $locationName 
     * @param  string  $exchangeAbbreviation 
     * @param  string  $futuresSymbol 
     * @param  string  $deliveryStart  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $deliveryEnd  of RFC-3339 format, IE: 2023-10-04T21:26:22+00:00
     * @param  string  $chainOrderId 
     */
    public function __construct(int $quantity, float $price, float $basisPrice, float $futuresPrice, ?string $comments, int $accountId, string $erpAccountId, string $erpCommodityId, string $erpLocationId, string $orderCreatedAt, string $expiresAt, bool $forceFill, bool $careOrder, string $contractSymbol, int $pricingType, string $unitOfMeasure, string $shortInstrumentGroupName, string $commodityName, string $locationName, string $exchangeAbbreviation, string $futuresSymbol, string $deliveryStart, string $deliveryEnd, string $chainOrderId)
    {
        $this->quantity = $quantity;
        $this->price = $price;
        $this->basisPrice = $basisPrice;
        $this->futuresPrice = $futuresPrice;
        $this->comments = $comments;
        $this->accountId = $accountId;
        $this->erpAccountId = $erpAccountId;
        $this->erpCommodityId = $erpCommodityId;
        $this->erpLocationId = $erpLocationId;
        $this->orderCreatedAt = $orderCreatedAt;
        $this->expiresAt = $expiresAt;
        $this->forceFill = $forceFill;
        $this->careOrder = $careOrder;
        $this->contractSymbol = $contractSymbol;
        $this->pricingType = $pricingType;
        $this->unitOfMeasure = $unitOfMeasure;
        $this->shortInstrumentGroupName = $shortInstrumentGroupName;
        $this->commodityName = $commodityName;
        $this->locationName = $locationName;
        $this->exchangeAbbreviation = $exchangeAbbreviation;
        $this->futuresSymbol = $futuresSymbol;
        $this->deliveryStart = $deliveryStart;
        $this->deliveryEnd = $deliveryEnd;
        $this->chainOrderId = $chainOrderId;
    }
    

}